
/* Common Open Systems Environment, Common Graphics Environment	 */		
/* Extension to	PEX 5.1	version	2.  File date: February	10, 1994 */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/


 /* =======================================================================
  * NOTE NOTE NOTE  Insert this	section
  *		    at the end of pl_oc_prim.c file
  * ====================================================================='=
  */

/***** Start of	Ext section ************/

#include "PEXExtlib.h"
#include "PEXExtlibint.h"


void
PEXExtEllipse (display,	resource_id, req_type, center, major, minor)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord		*center;
INPUT PEXVector		*major;
INPUT PEXVector		*minor;

{
    register pexExtEllipse	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtEllipse, resource_id, req_type,	req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_HTON	(center->z, req->center_z, fpFormat);
	FP_CONVERT_HTON	(major->x, req->major_x, fpFormat);
	FP_CONVERT_HTON	(major->y, req->major_y, fpFormat);
	FP_CONVERT_HTON	(major->z, req->major_z, fpFormat);
	FP_CONVERT_HTON	(minor->x, req->minor_x, fpFormat);
	FP_CONVERT_HTON	(minor->y, req->minor_y, fpFormat);
	FP_CONVERT_HTON	(minor->z, req->minor_z, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->center_z =	center->z;
	req->major_x = major->x;
	req->major_y = major->y;
	req->major_z = major->z;
	req->minor_x = minor->x;
	req->minor_y = minor->y;
	req->minor_z = minor->z;
    }

    END_SIMPLE_OC (ExtEllipse, resource_id, req_type, req);
}


void
PEXExtEllipse2D	(display, resource_id, req_type, center, major,	minor)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord2D	*center;
INPUT PEXVector2D	*major;
INPUT PEXVector2D	*minor;

{
    register pexExtEllipse2D	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtEllipse2D, resource_id,	req_type, req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_HTON	(major->x, req->major_x, fpFormat);
	FP_CONVERT_HTON	(major->y, req->major_y, fpFormat);
	FP_CONVERT_HTON	(minor->x, req->minor_x, fpFormat);
	FP_CONVERT_HTON	(minor->y, req->minor_y, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->major_x = major->x;
	req->major_y = major->y;
	req->minor_x = minor->x;
	req->minor_y = minor->y;
    }

    END_SIMPLE_OC (ExtEllipse2D, resource_id, req_type,	req);
}


void
PEXExtCircle2D (display, resource_id, req_type,	center,	radius)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord2D	*center;
INPUT double		radius;

{
    register pexExtCircle2D	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtCircle2D, resource_id, req_type, req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_DHTON (radius, req->radius, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->radius = radius;
    }

    END_SIMPLE_OC (ExtCircle2D,	resource_id, req_type, req);
}


void
PEXExtEllipticalArc (display, resource_id, req_type, 
    center, major, minor, start, stop)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord		*center;
INPUT PEXVector		*major;
INPUT PEXVector		*minor;
INPUT double		start;
INPUT double		stop;

{
    register pexExtEllipticalArc	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtEllipticalArc, resource_id, req_type, req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_HTON	(center->z, req->center_z, fpFormat);
	FP_CONVERT_HTON	(major->x, req->major_x, fpFormat);
	FP_CONVERT_HTON	(major->y, req->major_y, fpFormat);
	FP_CONVERT_HTON	(major->z, req->major_z, fpFormat);
	FP_CONVERT_HTON	(minor->x, req->minor_x, fpFormat);
	FP_CONVERT_HTON	(minor->y, req->minor_y, fpFormat);
	FP_CONVERT_HTON	(minor->z, req->minor_z, fpFormat);
	FP_CONVERT_DHTON (start, req->start_angle, fpFormat);
	FP_CONVERT_DHTON (stop,	req->stop_angle, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->center_z =	center->z;
	req->major_x = major->x;
	req->major_y = major->y;
	req->major_z = major->z;
	req->minor_x = minor->x;
	req->minor_y = minor->y;
	req->minor_z = minor->z;
	req->start_angle = start;
	req->stop_angle	= stop;
    }

    END_SIMPLE_OC (ExtEllipticalArc, resource_id, req_type, req);
}


void
PEXExtEllipticalArc2D (display,	resource_id, req_type,
    center, major, minor, start, stop)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord2D	*center;
INPUT PEXVector2D	*major;
INPUT PEXVector2D	*minor;
INPUT double		start;
INPUT double		stop;

{
    register pexExtEllipticalArc2D	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtEllipticalArc2D, resource_id, req_type,	req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_HTON	(major->x, req->major_x, fpFormat);
	FP_CONVERT_HTON	(major->y, req->major_y, fpFormat);
	FP_CONVERT_HTON	(minor->x, req->minor_x, fpFormat);
	FP_CONVERT_HTON	(minor->y, req->minor_y, fpFormat);
	FP_CONVERT_DHTON (start, req->start_angle, fpFormat);
	FP_CONVERT_DHTON (stop,	req->stop_angle, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->major_x = major->x;
	req->major_y = major->y;
	req->minor_x = minor->x;
	req->minor_y = minor->y;
	req->start_angle = start;
	req->stop_angle	= stop;
    }

    END_SIMPLE_OC (ExtEllipticalArc2D, resource_id, req_type, req);
}


void
PEXExtCircularArc2D (display, resource_id, req_type, 
center,	radius,	start, stop)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT PEXCoord2D	*center;
INPUT double		radius;
INPUT double		start;
INPUT double		stop;

{
    register pexExtCircularArc2D	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;

    BEGIN_SIMPLE_OC (ExtCircularArc2D, resource_id, req_type, req);
    CHECK_FP (fpConvert, fpFormat);

    if (fpConvert)
    {
	FP_CONVERT_HTON	(center->x, req->center_x, fpFormat);
	FP_CONVERT_HTON	(center->y, req->center_y, fpFormat);
	FP_CONVERT_DHTON (radius, req->radius, fpFormat);
	FP_CONVERT_DHTON (start, req->start_angle, fpFormat);
	FP_CONVERT_DHTON (stop,	req->stop_angle, fpFormat);
    }
    else
    {
	req->center_x =	center->x;
	req->center_y =	center->y;
	req->radius = radius;
	req->start_angle = start;
	req->stop_angle	= stop;
    }

    END_SIMPLE_OC (ExtCircularArc2D, resource_id, req_type, req);
}


void
PEXExtFillAreaSetWithData (display, resource_id, req_type,
    shape, ignoreEdges,	contourHint, vertexFPDataSize, facetAttributes,		
    vertexAttributes, colorType, numFillAreas, facetData, vertices)

INPUT Display		*display;
INPUT XID		resource_id;
INPUT PEXOCRequestType	req_type;
INPUT int		shape;
INPUT int		ignoreEdges;
INPUT int		contourHint;
INPUT unsigned int	vertexFPDataSize; 
INPUT unsigned int	facetAttributes;
INPUT unsigned int	vertexAttributes;
INPUT int		colorType;
INPUT unsigned int	numFillAreas;
INPUT PEXFacetData	*facetData;
INPUT PEXExtListOfVertex	*vertices;

{
    register pexExtFillAreaSetWithData	*req;
    char				*pBuf;
    int					fpConvert;
    int					fpFormat;
    int					dataLength;
    int					lenofColor;
    int					lenofFacet;
    int					lenofVertex;
    int					numVertices, i;
    char				*pData;


    /* 
     * Calculate the size of the facet data and	vertex data.
     */

    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXGAEdges)
	lenofVertex++;			/* edge	switch is CARD32 */

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));	

    for	(i = 0,	numVertices = 0; i < numFillAreas; i++)
	numVertices += vertices[i].count;


    /*
     * Initialize the OC request.
     */

    dataLength = lenofFacet + numFillAreas + numVertices * lenofVertex;

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtFillAreaSetWithData), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the fill area set request header data. 
     */

    CHECK_FP (fpConvert, fpFormat);

    BEGIN_OC_HEADER (ExtFillAreaSetWithData, dataLength, pBuf, req);

    req->shape = shape;
    req->ignoreEdges = ignoreEdges;
    req->contourHint = contourHint;
    req->colorType = colorType;
    req->facetAttribs =	facetAttributes;
    req->vertexAttribs = vertexAttributes;
    req->numVertexFPData = vertexFPDataSize;
    req->numLists = numFillAreas;

    END_OC_HEADER (ExtFillAreaSetWithData, pBuf, req);


    /*
     * Copy the	facet data
     */

    if (facetAttributes)
    {
	OC_FACET (colorType, facetAttributes, facetData, fpConvert, fpFormat);
    }


    /*
     * Copy the	polygon	vertices, preceded by a	count.
     * Note that the vertices are padded to end	on a word boundary.
     */

    for	(i = 0;	i < numFillAreas; i++)
    {
	pData =	(char *) PEXGetOCAddr (display,	SIZEOF (CARD32));
	PUT_CARD32 (vertices[i].count, pData);

	OC_LISTOF_EXT_VERTEX (vertices[i].count, lenofVertex, colorType,
	    vertexFPDataSize,
	    vertexAttributes, vertices[i].vertices, fpConvert, fpFormat);
    }

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}


void
PEXExtSetOfFillAreaSets	(display, resource_id, req_type, shape,
    vertexFPDataSize,
    facetAttributes, vertexAttributes, edgeAttributes, contourHint,
    contoursAllOne, colorType, numFillAreaSets,	facetData,
    numVertices, vertices, numIndices, edgeFlags, connectivity)

INPUT Display			*display;
INPUT XID			resource_id;
INPUT PEXOCRequestType		req_type;
INPUT int			shape;
INPUT unsigned int		vertexFPDataSize;
INPUT unsigned int		facetAttributes;
INPUT unsigned int		vertexAttributes;
INPUT unsigned int		edgeAttributes;
INPUT int			contourHint;
INPUT int			contoursAllOne;
INPUT int			colorType;
INPUT unsigned int		numFillAreaSets;
INPUT PEXArrayOfFacetData	facetData;
INPUT unsigned int		numVertices; 
INPUT PEXExtArrayOfVertex	vertices;
INPUT unsigned int		numIndices; 
INPUT PEXSwitch			*edgeFlags;
INPUT PEXConnectivityData	*connectivity;

{
    register pexExtSetOfFillAreaSets	*req;
    char				*pBuf;
    int					fpConvert;
    int					fpFormat;
    int					dataLength;
    PEXConnectivityData			*pConnectivity;
    PEXListOfUShort			*pList;
    int					lenofColor;
    int					lenofFacet;
    int					lenofVertex;
    int					sizeofEdge;
    int					numContours;
    int					count, scount;
    int					cbytes;
    int					i, j;
    char				*pData;


    /* 
     * Calculate the total number of contours.
     */

    numContours	= 0;
    pConnectivity = connectivity;
    for	(i = 0;	i < numFillAreaSets; i++, pConnectivity++)
	numContours += pConnectivity->count;


    /* 
     * Calculate the size of the facet data and	vertex data
     */

    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));	

    sizeofEdge = edgeAttributes	? SIZEOF (CARD8) : 0;

    cbytes = SIZEOF (CARD16) * (numFillAreaSets	+ numContours +	numIndices);


    /*
     * Initialize the OC request.
     */

    dataLength = (lenofFacet * numFillAreaSets)	+
	(lenofVertex * numVertices) + 
	NUMWORDS (sizeofEdge * numIndices) + NUMWORDS (cbytes);

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtSetOfFillAreaSets), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the SOFA request header data. 
     */

    CHECK_FP (fpConvert, fpFormat);

    BEGIN_OC_HEADER (ExtSetOfFillAreaSets, dataLength, pBuf, req);

    req->shape = shape;
    req->colorType = colorType;
    req->FAS_Attributes	= facetAttributes;
    req->vertexAttributes = vertexAttributes;
    req->edgeAttributes	= edgeAttributes ? PEXOn : PEXOff;
    req->numVertexFPData = vertexFPDataSize;
    req->contourHint = contourHint;
    req->contourCountsFlag = contoursAllOne;
    req->numFAS	= numFillAreaSets;
    req->numVertices = numVertices;
    req->numEdges = numIndices;
    req->numContours = numContours;

    END_OC_HEADER (ExtSetOfFillAreaSets, pBuf, req);


    /*
     * Copy the	facet data.
     */

    if (facetAttributes)
    {
	OC_LISTOF_FACET	(numFillAreaSets, lenofFacet, colorType,
	    facetAttributes, facetData,	fpConvert, fpFormat);
    }


    /*
     * Copy the	vertex data.
     */

    OC_LISTOF_EXT_VERTEX (numVertices, lenofVertex, colorType,
	vertexFPDataSize, vertexAttributes, vertices, fpConvert, fpFormat);


    /*
     * Copy the	edge data.
     */

    if (edgeAttributes)
    {
	OC_LISTOF_CARD8_PAD (numIndices, edgeFlags);
    }


    /*
     * Now add the connectivity	data.
     *
     * Unfortunately, the encoding for LISTofLISTofLISTofCARD16
     * is broken - there is no padding within this entity, just
     * at the end.  As a result, display->bufptr can be	on a
     * non word	aligned	boundary when _XSend or	_XFlush	is called!!!
     *
     * If the connectivity data	fits in	the X transport	buffer,
     * _XSend and _XFlush is not used, so we're	safe.
     *
     * If the connectivity data	doesn't	fit in the X transport buffer,
     * we fix the problem by putting the connectivity data in a	scratch
     * buffer, then using _XSend.
     */

    pConnectivity = connectivity;

    if ((cbytes	+ PAD (cbytes))	<= BytesLeftInXBuffer (display))
    {

	for (i = 0 ; i < numFillAreaSets; i++)
	{
	    count = pConnectivity->count;
	    pData = (char *) PEXGetOCAddr (display, SIZEOF (CARD16));
	    PUT_CARD16 (count, pData);

	    for	(j = 0,	pList =	pConnectivity->lists; j	< count; j++, pList++)
	    {
		scount = pList->count;
		pData =	(char *) PEXGetOCAddr (display,	SIZEOF (CARD16));
		PUT_CARD16 (scount, pData);

		OC_LISTOF_CARD16 (scount, pList->shorts);
	    }

	    pConnectivity++;
	}

	if (PAD	(cbytes))
	    PEXGetOCAddr (display, PAD (cbytes));
    }
    else
    {
      char *pStart = _XAllocScratch (display, cbytes + PAD (cbytes));
      pData = pStart;

      for (i = 0; i < numFillAreaSets; i++)
      {
	  count	= pConnectivity->count;
	  STORE_CARD16 (count, pData);

	  for (j = 0, pList = pConnectivity->lists; j <	count; j++, pList++)
	  {
	      scount = pList->count;
	      STORE_CARD16 (scount, pData);

	      STORE_LISTOF_CARD16 (scount, pList->shorts, pData);
	  }

	  pConnectivity++;
      }

      _XSend (display, pStart, cbytes +	PAD (cbytes));
    }

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}


void
PEXExtTriangleStrip (display, resource_id, req_type,
    vertexFPDataSize, facetAttributes, vertexAttributes, colorType,
    facetData, numVertices, vertices)

INPUT Display			*display;
INPUT XID			resource_id;
INPUT PEXOCRequestType		req_type;
INPUT unsigned int		vertexFPDataSize;
INPUT unsigned int		facetAttributes;
INPUT unsigned int		vertexAttributes;
INPUT int			colorType;
INPUT PEXArrayOfFacetData	facetData;
INPUT unsigned int		numVertices;
INPUT PEXExtArrayOfVertex	vertices;

{
    register pexExtTriangleStrip	*req;
    char			*pBuf;
    int				fpConvert;
    int				fpFormat;
    int				dataLength;
    int				lenofColor;
    int				lenofFacet;
    int				lenofVertex;


    /* 
     * Calculate number	of words in the	list of	facet data and the vertex list.
     */

    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));	

    /*
     * Initialize the OC request.
     */

    dataLength = (numVertices -	2) * lenofFacet	+ numVertices *	lenofVertex;

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtTriangleStrip), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the triangle strip	request	header data. 
     */

    CHECK_FP (fpConvert, fpFormat);

    BEGIN_OC_HEADER (ExtTriangleStrip, dataLength, pBuf, req);

    req->colorType = colorType;
    req->facetAttribs =	facetAttributes;
    req->vertexAttribs = vertexAttributes;
    req->numVertexFPData = vertexFPDataSize;
    req->numVertices = numVertices;

    END_OC_HEADER (ExtTriangleStrip, pBuf, req);


    /*
     * Copy the	facet data.
     */

    if (facetAttributes)
    {
	OC_LISTOF_FACET	((numVertices -	2), lenofFacet,	colorType,
	    facetAttributes, facetData,	fpConvert, fpFormat);
    }


    /*
     * Copy the	vertex data.
     */

    OC_LISTOF_EXT_VERTEX (numVertices, lenofVertex, colorType,
	vertexFPDataSize, vertexAttributes, vertices, fpConvert, fpFormat);

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}


void
PEXExtQuadrilateralMesh	(display, resource_id, req_type,
    shape, vertexFPDataSize, facetAttributes, vertexAttributes,	colorType,
    facetData, colCount, rowCount, vertices)

INPUT Display			*display;
INPUT XID			resource_id;
INPUT PEXOCRequestType		req_type;
INPUT int			shape;
INPUT unsigned int		vertexFPDataSize;
INPUT unsigned int		facetAttributes;
INPUT unsigned int		vertexAttributes;
INPUT int			colorType;
INPUT PEXArrayOfFacetData	facetData;
INPUT unsigned int		colCount;
INPUT unsigned int		rowCount;
INPUT PEXExtArrayOfVertex	vertices;

{
    register pexExtQuadrilateralMesh	*req;
    char				*pBuf;
    int					fpConvert;
    int					fpFormat;
    int					dataLength;
    int					lenofColor;
    int					lenofFacet;
    int					lenofVertex;


    /* 
     * Calculate the number of words in	the facet data list and	vertex list.
     */

    lenofColor = GetColorLength	(colorType);
    lenofFacet = GetFacetDataLength (facetAttributes, lenofColor); 
    lenofVertex	= GetVertexWithDataLength (vertexAttributes, lenofColor);

    if (vertexAttributes & PEXExtGAData)
	lenofVertex += NUMWORDS	(vertexFPDataSize * SIZEOF (PEXFLOAT));	

    /*
     * Initialize the OC request.
     */

    dataLength = (((rowCount - 1) * (colCount -	1)) * lenofFacet) +
	(rowCount * colCount * lenofVertex);

    PEXInitOC (display,	resource_id, req_type,
	LENOF (pexExtQuadrilateralMesh), dataLength, pBuf);

    if (pBuf ==	NULL) return;


    /* 
     * Store the quad mesh request header data.	
     */

    CHECK_FP (fpConvert, fpFormat);

    BEGIN_OC_HEADER (ExtQuadrilateralMesh, dataLength, pBuf, req);

    req->colorType = colorType;
    req->mPts =	colCount;
    req->nPts =	rowCount;
    req->facetAttribs =	facetAttributes;
    req->vertexAttribs = vertexAttributes;
    req->numVertexFPData = vertexFPDataSize;
    req->shape = shape;

    END_OC_HEADER (ExtQuadrilateralMesh, pBuf, req);
 

    /*
     * Copy the	facet data.
     */

    if (facetAttributes)
    {
	OC_LISTOF_FACET	((rowCount - 1)	* (colCount - 1), lenofFacet,
	    colorType, facetAttributes,	facetData, fpConvert, fpFormat);
    }


    /*
     * Copy the	vertex data.
     */

    OC_LISTOF_EXT_VERTEX (rowCount * colCount, lenofVertex, colorType,
	vertexFPDataSize, vertexAttributes, vertices, fpConvert, fpFormat);

    PEXFinishOC	(display);
    PEXSyncHandle (display);
}
/***** End of Ext section ************/
